import { Rule } from 'eslint';
import type { TSESLint } from '@typescript-eslint/utils';
import type { FlatConfig } from '@typescript-eslint/utils/ts-eslint';
/**
 * Maps ESLint rule keys declared in the JavaScript checks to rule implementations
 */
declare const rules: {
    [key: string]: Rule.RuleModule;
};
export declare const configs: {
    recommended: FlatConfig.Config;
    'recommended-legacy': TSESLint.ClassicConfig.Config;
};
export declare const meta: {
    name: string | undefined;
    version: string | undefined;
};
export { rules };
declare const _default: {
    rules: {
        [key: string]: Rule.RuleModule;
    };
    configs: {
        recommended: FlatConfig.Config;
        'recommended-legacy': TSESLint.ClassicConfig.Config;
    };
    meta: {
        name: string | undefined;
        version: string | undefined;
    };
};
export default _default;
export * from './helpers';
