"use strict";
/*
 * SonarQube JavaScript Plugin
 * Copyright (C) 2011-2024 SonarSource SA
 * mailto:info AT sonarsource DOT com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rules = exports.meta = exports.configs = void 0;
const fs_1 = __importDefault(require("fs"));
const helpers_1 = require("./helpers");
const S2376_1 = require("./S2376"); // accessor-pairs
const S1077_1 = require("./S1077"); // alt-text
const S6827_1 = require("./S6827"); // anchor-has-content
const S6844_1 = require("./S6844"); // anchor-is-valid
const S5850_1 = require("./S5850"); // anchor-precedence
const S3782_1 = require("./S3782"); // argument-type
const S2234_1 = require("./S2234"); // arguments-order
const S3513_1 = require("./S3513"); // arguments-usage
const S3796_1 = require("./S3796"); // array-callback-without-return
const S1528_1 = require("./S1528"); // array-constructor
const S3524_1 = require("./S3524"); // arrow-function-convention
const S2699_1 = require("./S2699"); // assertions-in-tests
const S6333_1 = require("./S6333"); // aws-apigateway-public-api
const S6329_1 = require("./S6329"); // aws-ec2-rds-dms-public
const S6275_1 = require("./S6275"); // aws-ec2-unencrypted-ebs-volume
const S6332_1 = require("./S6332"); // aws-efs-unencrypted
const S6302_1 = require("./S6302"); // aws-iam-all-privileges
const S6304_1 = require("./S6304"); // aws-iam-all-resources-accessible
const S6317_1 = require("./S6317"); // aws-iam-privilege-escalation
const S6270_1 = require("./S6270"); // aws-iam-public-access
const S6308_1 = require("./S6308"); // aws-opensearchservice-domain
const S6303_1 = require("./S6303"); // aws-rds-unencrypted-databases
const S6321_1 = require("./S6321"); // aws-restricted-ip-admin-access
const S6265_1 = require("./S6265"); // aws-s3-bucket-granted-access
const S6249_1 = require("./S6249"); // aws-s3-bucket-insecure-http
const S6281_1 = require("./S6281"); // aws-s3-bucket-public-access
const S6245_1 = require("./S6245"); // aws-s3-bucket-server-encryption
const S6252_1 = require("./S6252"); // aws-s3-bucket-versioning
const S6319_1 = require("./S6319"); // aws-sagemaker-unencrypted-notebook
const S6327_1 = require("./S6327"); // aws-sns-unencrypted-topics
const S6330_1 = require("./S6330"); // aws-sqs-unencrypted-queue
const S1529_1 = require("./S1529"); // bitwise-operators
const S4798_1 = require("./S4798"); // bool-param-default
const S1105_1 = require("./S1105"); // brace-style
const S1472_1 = require("./S1472"); // call-argument-line
const S5742_1 = require("./S5742"); // certificate-transparency
const S6092_1 = require("./S6092"); // chai-determinate-assertion
const S101_1 = require("./S101"); // class-name
const S3525_1 = require("./S3525"); // class-prototype
const S1523_1 = require("./S1523"); // code-eval
const S3776_1 = require("./S3776"); // cognitive-complexity
const S3616_1 = require("./S3616"); // comma-or-logical-or-case
const S124_1 = require("./S124"); // comment-regex
const S6353_1 = require("./S6353"); // concise-regex
const S3973_1 = require("./S3973"); // conditional-indentation
const S5757_1 = require("./S5757"); // confidential-information-logging
const S1848_1 = require("./S1848"); // constructor-for-side-effects
const S5693_1 = require("./S5693"); // content-length
const S5728_1 = require("./S5728"); // content-security-policy
const S3330_1 = require("./S3330"); // cookie-no-httponly
const S2255_1 = require("./S2255"); // cookies
const S5122_1 = require("./S5122"); // cors
const S4502_1 = require("./S4502"); // csrf
const S1541_1 = require("./S1541"); // cyclomatic-complexity
const S3798_1 = require("./S3798"); // declarations-in-global-scope
const S1788_1 = require("./S1788"); // default-param-last
const S1874_1 = require("./S1874"); // deprecation
const S3514_1 = require("./S3514"); // destructuring-assignment-syntax
const S3403_1 = require("./S3403"); // different-types-comparison
const S5247_1 = require("./S5247"); // disabled-auto-escaping
const S5725_1 = require("./S5725"); // disabled-resource-integrity
const S6080_1 = require("./S6080"); // disabled-timeout
const S5743_1 = require("./S5743"); // dns-prefetching
const S5869_1 = require("./S5869"); // duplicates-in-character-class
const S126_1 = require("./S126"); // elseif-without-else
const S5842_1 = require("./S5842"); // empty-string-repetition
const S4787_1 = require("./S4787"); // encryption
const S5542_1 = require("./S5542"); // encryption-secure-mode
const S3723_1 = require("./S3723"); // enforce-trailing-comma
const S6328_1 = require("./S6328"); // existing-groups
const S1067_1 = require("./S1067"); // expression-complexity
const S1451_1 = require("./S1451"); // file-header
const S3317_1 = require("./S3317"); // file-name-differ-from-class
const S2612_1 = require("./S2612"); // file-permissions
const S2598_1 = require("./S2598"); // file-uploads
const S1134_1 = require("./S1134"); // fixme-tag
const S1535_1 = require("./S1535"); // for-in
const S2251_1 = require("./S2251"); // for-loop-increment-sign
const S5732_1 = require("./S5732"); // frame-ancestors
const S1515_1 = require("./S1515"); // function-inside-loop
const S100_1 = require("./S100"); // function-name
const S3800_1 = require("./S3800"); // function-return-type
const S1527_1 = require("./S1527"); // future-reserved-words
const S3531_1 = require("./S3531"); // generator-without-yield
const S4790_1 = require("./S4790"); // hashing
const S5691_1 = require("./S5691"); // hidden-files
const S6754_1 = require("./S6754"); // hook-use-state
const S5254_1 = require("./S5254"); // html-has-lang
const S3785_1 = require("./S3785"); // in-operator-type-error
const S3686_1 = require("./S3686"); // inconsistent-function-call
const S2692_1 = require("./S2692"); // index-of-compare-to-positive-number
const S2092_1 = require("./S2092"); // insecure-cookie
const S5659_1 = require("./S5659"); // insecure-jwt-token
const S3415_1 = require("./S3415"); // inverted-assertion-arguments
const S6477_1 = require("./S6477"); // jsx-key
const S6481_1 = require("./S6481"); // jsx-no-constructed-context-values
const S6749_1 = require("./S6749"); // jsx-no-useless-fragment
const S6853_1 = require("./S6853"); // label-has-associated-control
const S1439_1 = require("./S1439"); // label-position
const S5148_1 = require("./S5148"); // link-with-target-blank
const S1479_1 = require("./S1479"); // max-switch-cases
const S4622_1 = require("./S4622"); // max-union-size
const S4084_1 = require("./S4084"); // media-has-caption
const S1994_1 = require("./S1994"); // misplaced-loop-counter
const S1082_1 = require("./S1082"); // mouse-events-a11y
const S134_1 = require("./S134"); // nested-control-flow
const S2430_1 = require("./S2430"); // new-cap
const S2999_1 = require("./S2999"); // new-operator-misuse
const S4275_1 = require("./S4275"); // no-accessor-field-mismatch
const S3923_1 = require("./S3923"); // no-all-duplicated-branches
const S2871_1 = require("./S2871"); // no-alphabetical-sort
const S6268_1 = require("./S6268"); // no-angular-bypass-sanitization
const S2870_1 = require("./S2870"); // no-array-delete
const S6479_1 = require("./S6479"); // no-array-index-key
const S3579_1 = require("./S3579"); // no-associative-arrays
const S6551_1 = require("./S6551"); // no-base-to-string
const S2424_1 = require("./S2424"); // no-built-in-override
const S1219_1 = require("./S1219"); // no-case-label-in-switch
const S5332_1 = require("./S5332"); // no-clear-text-protocols
const S6079_1 = require("./S6079"); // no-code-after-done
const S1066_1 = require("./S1066"); // no-collapsible-if
const S3981_1 = require("./S3981"); // no-collection-size-mischeck
const S125_1 = require("./S125"); // no-commented-code
const S1854_1 = require("./S1854"); // no-dead-store
const S3001_1 = require("./S3001"); // no-delete-var
const S6957_1 = require("./S6957"); // no-deprecated-react
const S4621_1 = require("./S4621"); // no-duplicate-in-composite
const S1192_1 = require("./S1192"); // no-duplicate-string
const S1871_1 = require("./S1871"); // no-duplicated-branches
const S4143_1 = require("./S4143"); // no-element-overwrite
const S6019_1 = require("./S6019"); // no-empty-after-reluctant
const S6323_1 = require("./S6323"); // no-empty-alternatives
const S4158_1 = require("./S4158"); // no-empty-collection
const S1186_1 = require("./S1186"); // no-empty-function
const S6331_1 = require("./S6331"); // no-empty-group
const S4023_1 = require("./S4023"); // no-empty-interface
const S2187_1 = require("./S2187"); // no-empty-test-file
const S888_1 = require("./S888"); // no-equals-in-for-termination
const S6426_1 = require("./S6426"); // no-exclusive-tests
const S6643_1 = require("./S6643"); // no-extend-native
const S930_1 = require("./S930"); // no-extra-arguments
const S1116_1 = require("./S1116"); // no-extra-semi
const S6788_1 = require("./S6788"); // no-find-dom-node
const S4139_1 = require("./S4139"); // no-for-in-iterable
const S1530_1 = require("./S1530"); // no-function-declaration-in-block
const S2990_1 = require("./S2990"); // no-global-this
const S2137_1 = require("./S2137"); // no-globals-shadowing
const S2589_1 = require("./S2589"); // no-gratuitous-expressions
const S2068_1 = require("./S2068"); // no-hardcoded-credentials
const S1313_1 = require("./S1313"); // no-hardcoded-ip
const S6442_1 = require("./S6442"); // no-hook-setter-in-body
const S1862_1 = require("./S1862"); // no-identical-conditions
const S1764_1 = require("./S1764"); // no-identical-expressions
const S4144_1 = require("./S4144"); // no-identical-functions
const S2486_1 = require("./S2486"); // no-ignored-exceptions
const S2201_1 = require("./S2201"); // no-ignored-return
const S4328_1 = require("./S4328"); // no-implicit-dependencies
const S2703_1 = require("./S2703"); // no-implicit-global
const S4619_1 = require("./S4619"); // no-in-misuse
const S1940_1 = require("./S1940"); // no-inverted-boolean-check
const S2970_1 = require("./S2970"); // no-incomplete-assertions
const S3801_1 = require("./S3801"); // no-inconsistent-returns
const S3402_1 = require("./S3402"); // no-incorrect-string-concat
const S2189_1 = require("./S2189"); // no-infinite-loop
const S5604_1 = require("./S5604"); // no-intrusive-permissions
const S4123_1 = require("./S4123"); // no-invalid-await
const S3516_1 = require("./S3516"); // no-invariant-returns
const S5759_1 = require("./S5759"); // no-ip-forward
const S1119_1 = require("./S1119"); // no-labels
const S6958_1 = require("./S6958"); // no-literal-call
const S6660_1 = require("./S6660"); // no-lonely-if
const S5734_1 = require("./S5734"); // no-mime-sniff
const S4043_1 = require("./S4043"); // no-misleading-array-reverse
const S6544_1 = require("./S6544"); // no-misused-promises
const S5730_1 = require("./S5730"); // no-mixed-content
const S1121_1 = require("./S1121"); // no-nested-assignment
const S3358_1 = require("./S3358"); // no-nested-conditional
const S2004_1 = require("./S2004"); // no-nested-functions
const S1821_1 = require("./S1821"); // no-nested-switch
const S4624_1 = require("./S4624"); // no-nested-template-literals
const S881_1 = require("./S881"); // no-nested-incdec
const S1751_1 = require("./S1751"); // no-one-iteration-loop
const S4036_1 = require("./S4036"); // no-os-command-from-path
const S1226_1 = require("./S1226"); // no-parameter-reassignment
const S1533_1 = require("./S1533"); // no-primitive-wrappers
const S2814_1 = require("./S2814"); // no-redeclare
const S4165_1 = require("./S4165"); // no-redundant-assignments
const S1125_1 = require("./S1125"); // no-redundant-boolean
const S3626_1 = require("./S3626"); // no-redundant-jump
const S4782_1 = require("./S4782"); // no-redundant-optional
const S1110_1 = require("./S1110"); // no-redundant-parentheses
const S6571_1 = require("./S6571"); // no-redundant-type-constituents
const S3827_1 = require("./S3827"); // no-reference-error
const S5736_1 = require("./S5736"); // no-referrer-policy
const S3533_1 = require("./S3533"); // no-require-or-define
const S4324_1 = require("./S4324"); // no-return-type-any
const S5863_1 = require("./S5863"); // no-same-argument-assert
const S3972_1 = require("./S3972"); // no-same-line-conditional
const S6679_1 = require("./S6679"); // no-self-compare
const S1301_1 = require("./S1301"); // no-small-switch
const S105_1 = require("./S105"); // no-tab
const S5257_1 = require("./S5257"); // no-table-as-layout
const S4327_1 = require("./S4327"); // no-this-alias
const S3696_1 = require("./S3696"); // no-throw-literal
const S4822_1 = require("./S4822"); // no-try-promise
const S4623_1 = require("./S4623"); // no-undefined-argument
const S2138_1 = require("./S2138"); // no-undefined-assignment
const S2681_1 = require("./S2681"); // no-unenclosed-multiline-block
const S6486_1 = require("./S6486"); // no-uniq-key
const S6747_1 = require("./S6747"); // no-unknown-property
const S1763_1 = require("./S1763"); // no-unreachable
const S6791_1 = require("./S6791"); // no-unsafe
const S5042_1 = require("./S5042"); // no-unsafe-unzip
const S6478_1 = require("./S6478"); // no-unstable-nested-components
const S3984_1 = require("./S3984"); // no-unthrown-error
const S4030_1 = require("./S4030"); // no-unused-collection
const S905_1 = require("./S905"); // no-unused-expressions
const S1172_1 = require("./S1172"); // no-unused-function-argument
const S1068_1 = require("./S1068"); // no-unused-private-class-members
const S3699_1 = require("./S3699"); // no-use-of-empty-return-value
const S6676_1 = require("./S6676"); // no-useless-call
const S2737_1 = require("./S2737"); // no-useless-catch
const S6647_1 = require("./S6647"); // no-useless-constructor
const S2123_1 = require("./S2123"); // no-useless-increment
const S4335_1 = require("./S4335"); // no-useless-intersection
const S6443_1 = require("./S6443"); // no-useless-react-setstate
const S3504_1 = require("./S3504"); // no-var
const S1526_1 = require("./S1526"); // no-variable-usage-before-declaration
const S6299_1 = require("./S6299"); // no-vue-bypass-sanitization
const S5547_1 = require("./S5547"); // no-weak-cipher
const S4426_1 = require("./S4426"); // no-weak-keys
const S2208_1 = require("./S2208"); // no-wildcard-import
const S2757_1 = require("./S2757"); // non-existent-operator
const S3760_1 = require("./S3760"); // non-number-in-arithmetic-expression
const S2259_1 = require("./S2259"); // null-dereference
const S5264_1 = require("./S5264"); // object-alt-content
const S3498_1 = require("./S3498"); // object-shorthand
const S3757_1 = require("./S3757"); // operation-returning-nan
const S4721_1 = require("./S4721"); // os-command
const S2819_1 = require("./S2819"); // post-message
const S4524_1 = require("./S4524"); // prefer-default-last
const S6572_1 = require("./S6572"); // prefer-enum-initializers
const S4138_1 = require("./S4138"); // prefer-for-of
const S6598_1 = require("./S6598"); // prefer-function-type
const S1488_1 = require("./S1488"); // prefer-immediate-return
const S4156_1 = require("./S4156"); // prefer-namespace-keyword
const S6606_1 = require("./S6606"); // prefer-nullish-coalescing
const S2428_1 = require("./S2428"); // prefer-object-literal
const S6661_1 = require("./S6661"); // prefer-object-spread
const S4634_1 = require("./S4634"); // prefer-promise-shorthand
const S1126_1 = require("./S1126"); // prefer-single-boolean-return
const S6666_1 = require("./S6666"); // prefer-spread
const S6557_1 = require("./S6557"); // prefer-string-starts-ends-with
const S3512_1 = require("./S3512"); // prefer-template
const S4322_1 = require("./S4322"); // prefer-type-guard
const S1264_1 = require("./S1264"); // prefer-while
const S4823_1 = require("./S4823"); // process-argv
const S4507_1 = require("./S4507"); // production-debug
const S2245_1 = require("./S2245"); // pseudo-random
const S1444_1 = require("./S1444"); // public-static-readonly
const S5443_1 = require("./S5443"); // publicly-writable-directories
const S6959_1 = require("./S6959"); // reduce-initial-value
const S6564_1 = require("./S6564"); // redundant-type-aliases
const S5843_1 = require("./S5843"); // regex-complexity
const S4784_1 = require("./S4784"); // regular-expr
const S6440_1 = require("./S6440"); // rules-of-hooks
const S1438_1 = require("./S1438"); // semi
const S5876_1 = require("./S5876"); // session-regeneration
const S3499_1 = require("./S3499"); // shorthand-property-grouping
const S6397_1 = require("./S6397"); // single-char-in-character-classes
const S6035_1 = require("./S6035"); // single-character-alternation
const S5852_1 = require("./S5852"); // slow-regex
const S4818_1 = require("./S4818"); // sockets
const S2392_1 = require("./S2392"); // sonar-block-scoped-var
const S6439_1 = require("./S6439"); // sonar-jsx-no-leaked-render
const S104_1 = require("./S104"); // sonar-max-lines
const S138_1 = require("./S138"); // sonar-max-lines-per-function
const S107_1 = require("./S107"); // sonar-max-params
const S6324_1 = require("./S6324"); // sonar-no-control-regex
const S1534_1 = require("./S1534"); // sonar-no-dupe-keys
const S2639_1 = require("./S2639"); // sonar-no-empty-character-class
const S128_1 = require("./S128"); // sonar-no-fallthrough
const S5856_1 = require("./S5856"); // sonar-no-invalid-regexp
const S109_1 = require("./S109"); // sonar-no-magic-numbers
const S5868_1 = require("./S5868"); // sonar-no-misleading-character-class
const S6326_1 = require("./S6326"); // sonar-no-regex-spaces
const S6441_1 = require("./S6441"); // sonar-no-unused-class-component-methods
const S1481_1 = require("./S1481"); // sonar-no-unused-vars
const S6582_1 = require("./S6582"); // sonar-prefer-optional-chain
const S6759_1 = require("./S6759"); // sonar-prefer-read-only-props
const S6594_1 = require("./S6594"); // sonar-prefer-regexp-exec
const S2077_1 = require("./S2077"); // sql-queries
const S5973_1 = require("./S5973"); // stable-tests
const S4829_1 = require("./S4829"); // standard-input
const S6351_1 = require("./S6351"); // stateful-regex
const S5739_1 = require("./S5739"); // strict-transport-security
const S3003_1 = require("./S3003"); // strings-comparison
const S3854_1 = require("./S3854"); // super-invocation
const S131_1 = require("./S131"); // switch-without-default
const S5256_1 = require("./S5256"); // table-header
const S5260_1 = require("./S5260"); // table-header-reference
const S5958_1 = require("./S5958"); // test-check-exception
const S1135_1 = require("./S1135"); // todo-tag
const S135_1 = require("./S135"); // too-many-break-or-continue-in-loop
const S5867_1 = require("./S5867"); // unicode-aware-regex
const S6535_1 = require("./S6535"); // unnecessary-character-escapes
const S1128_1 = require("./S1128"); // unused-import
const S5860_1 = require("./S5860"); // unused-named-groups
const S4830_1 = require("./S4830"); // unverified-certificate
const S5527_1 = require("./S5527"); // unverified-hostname
const S3500_1 = require("./S3500"); // updated-const-var
const S2310_1 = require("./S2310"); // updated-loop-counter
const S2688_1 = require("./S2688"); // use-isnan
const S4323_1 = require("./S4323"); // use-type-alias
const S1154_1 = require("./S1154"); // useless-string-operation
const S3758_1 = require("./S3758"); // values-not-convertible-to-numbers
const S117_1 = require("./S117"); // variable-name
const S3735_1 = require("./S3735"); // void-use
const S4423_1 = require("./S4423"); // weak-ssl
const S2817_1 = require("./S2817"); // web-sql-database
const S5689_1 = require("./S5689"); // x-powered-by
const S2755_1 = require("./S2755"); // xml-parser-xxe
const S4817_1 = require("./S4817"); // xpath
/**
 * Maps ESLint rule keys declared in the JavaScript checks to rule implementations
 */
const rules = {};
exports.rules = rules;
rules['accessor-pairs'] = S2376_1.rule;
rules['alt-text'] = S1077_1.rule;
rules['anchor-has-content'] = S6827_1.rule;
rules['anchor-is-valid'] = S6844_1.rule;
rules['anchor-precedence'] = S5850_1.rule;
rules['argument-type'] = S3782_1.rule;
rules['arguments-order'] = S2234_1.rule;
rules['arguments-usage'] = S3513_1.rule;
rules['array-callback-without-return'] = S3796_1.rule;
rules['array-constructor'] = S1528_1.rule;
rules['arrow-function-convention'] = S3524_1.rule;
rules['assertions-in-tests'] = S2699_1.rule;
rules['aws-apigateway-public-api'] = S6333_1.rule;
rules['aws-ec2-rds-dms-public'] = S6329_1.rule;
rules['aws-ec2-unencrypted-ebs-volume'] = S6275_1.rule;
rules['aws-efs-unencrypted'] = S6332_1.rule;
rules['aws-iam-all-privileges'] = S6302_1.rule;
rules['aws-iam-all-resources-accessible'] = S6304_1.rule;
rules['aws-iam-privilege-escalation'] = S6317_1.rule;
rules['aws-iam-public-access'] = S6270_1.rule;
rules['aws-opensearchservice-domain'] = S6308_1.rule;
rules['aws-rds-unencrypted-databases'] = S6303_1.rule;
rules['aws-restricted-ip-admin-access'] = S6321_1.rule;
rules['aws-s3-bucket-granted-access'] = S6265_1.rule;
rules['aws-s3-bucket-insecure-http'] = S6249_1.rule;
rules['aws-s3-bucket-public-access'] = S6281_1.rule;
rules['aws-s3-bucket-server-encryption'] = S6245_1.rule;
rules['aws-s3-bucket-versioning'] = S6252_1.rule;
rules['aws-sagemaker-unencrypted-notebook'] = S6319_1.rule;
rules['aws-sns-unencrypted-topics'] = S6327_1.rule;
rules['aws-sqs-unencrypted-queue'] = S6330_1.rule;
rules['bitwise-operators'] = S1529_1.rule;
rules['bool-param-default'] = S4798_1.rule;
rules['brace-style'] = S1105_1.rule;
rules['call-argument-line'] = S1472_1.rule;
rules['certificate-transparency'] = S5742_1.rule;
rules['chai-determinate-assertion'] = S6092_1.rule;
rules['class-name'] = S101_1.rule;
rules['class-prototype'] = S3525_1.rule;
rules['code-eval'] = S1523_1.rule;
rules['cognitive-complexity'] = S3776_1.rule;
rules['comma-or-logical-or-case'] = S3616_1.rule;
rules['comment-regex'] = S124_1.rule;
rules['concise-regex'] = S6353_1.rule;
rules['conditional-indentation'] = S3973_1.rule;
rules['confidential-information-logging'] = S5757_1.rule;
rules['constructor-for-side-effects'] = S1848_1.rule;
rules['content-length'] = S5693_1.rule;
rules['content-security-policy'] = S5728_1.rule;
rules['cookie-no-httponly'] = S3330_1.rule;
rules['cookies'] = S2255_1.rule;
rules['cors'] = S5122_1.rule;
rules['csrf'] = S4502_1.rule;
rules['cyclomatic-complexity'] = S1541_1.rule;
rules['declarations-in-global-scope'] = S3798_1.rule;
rules['default-param-last'] = S1788_1.rule;
rules['deprecation'] = S1874_1.rule;
rules['destructuring-assignment-syntax'] = S3514_1.rule;
rules['different-types-comparison'] = S3403_1.rule;
rules['disabled-auto-escaping'] = S5247_1.rule;
rules['disabled-resource-integrity'] = S5725_1.rule;
rules['disabled-timeout'] = S6080_1.rule;
rules['dns-prefetching'] = S5743_1.rule;
rules['duplicates-in-character-class'] = S5869_1.rule;
rules['elseif-without-else'] = S126_1.rule;
rules['empty-string-repetition'] = S5842_1.rule;
rules['encryption'] = S4787_1.rule;
rules['encryption-secure-mode'] = S5542_1.rule;
rules['enforce-trailing-comma'] = S3723_1.rule;
rules['existing-groups'] = S6328_1.rule;
rules['expression-complexity'] = S1067_1.rule;
rules['file-header'] = S1451_1.rule;
rules['file-name-differ-from-class'] = S3317_1.rule;
rules['file-permissions'] = S2612_1.rule;
rules['file-uploads'] = S2598_1.rule;
rules['fixme-tag'] = S1134_1.rule;
rules['for-in'] = S1535_1.rule;
rules['for-loop-increment-sign'] = S2251_1.rule;
rules['frame-ancestors'] = S5732_1.rule;
rules['function-inside-loop'] = S1515_1.rule;
rules['function-name'] = S100_1.rule;
rules['function-return-type'] = S3800_1.rule;
rules['future-reserved-words'] = S1527_1.rule;
rules['generator-without-yield'] = S3531_1.rule;
rules['hashing'] = S4790_1.rule;
rules['hidden-files'] = S5691_1.rule;
rules['hook-use-state'] = S6754_1.rule;
rules['html-has-lang'] = S5254_1.rule;
rules['in-operator-type-error'] = S3785_1.rule;
rules['inconsistent-function-call'] = S3686_1.rule;
rules['index-of-compare-to-positive-number'] = S2692_1.rule;
rules['insecure-cookie'] = S2092_1.rule;
rules['insecure-jwt-token'] = S5659_1.rule;
rules['inverted-assertion-arguments'] = S3415_1.rule;
rules['jsx-key'] = S6477_1.rule;
rules['jsx-no-constructed-context-values'] = S6481_1.rule;
rules['jsx-no-useless-fragment'] = S6749_1.rule;
rules['label-has-associated-control'] = S6853_1.rule;
rules['label-position'] = S1439_1.rule;
rules['link-with-target-blank'] = S5148_1.rule;
rules['max-switch-cases'] = S1479_1.rule;
rules['max-union-size'] = S4622_1.rule;
rules['media-has-caption'] = S4084_1.rule;
rules['misplaced-loop-counter'] = S1994_1.rule;
rules['mouse-events-a11y'] = S1082_1.rule;
rules['nested-control-flow'] = S134_1.rule;
rules['new-cap'] = S2430_1.rule;
rules['new-operator-misuse'] = S2999_1.rule;
rules['no-accessor-field-mismatch'] = S4275_1.rule;
rules['no-all-duplicated-branches'] = S3923_1.rule;
rules['no-alphabetical-sort'] = S2871_1.rule;
rules['no-angular-bypass-sanitization'] = S6268_1.rule;
rules['no-array-delete'] = S2870_1.rule;
rules['no-array-index-key'] = S6479_1.rule;
rules['no-associative-arrays'] = S3579_1.rule;
rules['no-base-to-string'] = S6551_1.rule;
rules['no-built-in-override'] = S2424_1.rule;
rules['no-case-label-in-switch'] = S1219_1.rule;
rules['no-clear-text-protocols'] = S5332_1.rule;
rules['no-code-after-done'] = S6079_1.rule;
rules['no-collapsible-if'] = S1066_1.rule;
rules['no-collection-size-mischeck'] = S3981_1.rule;
rules['no-commented-code'] = S125_1.rule;
rules['no-dead-store'] = S1854_1.rule;
rules['no-delete-var'] = S3001_1.rule;
rules['no-deprecated-react'] = S6957_1.rule;
rules['no-duplicate-in-composite'] = S4621_1.rule;
rules['no-duplicate-string'] = S1192_1.rule;
rules['no-duplicated-branches'] = S1871_1.rule;
rules['no-element-overwrite'] = S4143_1.rule;
rules['no-empty-after-reluctant'] = S6019_1.rule;
rules['no-empty-alternatives'] = S6323_1.rule;
rules['no-empty-collection'] = S4158_1.rule;
rules['no-empty-function'] = S1186_1.rule;
rules['no-empty-group'] = S6331_1.rule;
rules['no-empty-interface'] = S4023_1.rule;
rules['no-empty-test-file'] = S2187_1.rule;
rules['no-equals-in-for-termination'] = S888_1.rule;
rules['no-exclusive-tests'] = S6426_1.rule;
rules['no-extend-native'] = S6643_1.rule;
rules['no-extra-arguments'] = S930_1.rule;
rules['no-extra-semi'] = S1116_1.rule;
rules['no-find-dom-node'] = S6788_1.rule;
rules['no-for-in-iterable'] = S4139_1.rule;
rules['no-function-declaration-in-block'] = S1530_1.rule;
rules['no-global-this'] = S2990_1.rule;
rules['no-globals-shadowing'] = S2137_1.rule;
rules['no-gratuitous-expressions'] = S2589_1.rule;
rules['no-hardcoded-credentials'] = S2068_1.rule;
rules['no-hardcoded-ip'] = S1313_1.rule;
rules['no-hook-setter-in-body'] = S6442_1.rule;
rules['no-identical-conditions'] = S1862_1.rule;
rules['no-identical-expressions'] = S1764_1.rule;
rules['no-identical-functions'] = S4144_1.rule;
rules['no-ignored-exceptions'] = S2486_1.rule;
rules['no-ignored-return'] = S2201_1.rule;
rules['no-implicit-dependencies'] = S4328_1.rule;
rules['no-implicit-global'] = S2703_1.rule;
rules['no-in-misuse'] = S4619_1.rule;
rules['no-incomplete-assertions'] = S2970_1.rule;
rules['no-inconsistent-returns'] = S3801_1.rule;
rules['no-incorrect-string-concat'] = S3402_1.rule;
rules['no-infinite-loop'] = S2189_1.rule;
rules['no-intrusive-permissions'] = S5604_1.rule;
rules['no-invalid-await'] = S4123_1.rule;
rules['no-invariant-returns'] = S3516_1.rule;
rules['no-inverted-boolean-check'] = S1940_1.rule;
rules['no-ip-forward'] = S5759_1.rule;
rules['no-labels'] = S1119_1.rule;
rules['no-literal-call'] = S6958_1.rule;
rules['no-lonely-if'] = S6660_1.rule;
rules['no-mime-sniff'] = S5734_1.rule;
rules['no-misleading-array-reverse'] = S4043_1.rule;
rules['no-misused-promises'] = S6544_1.rule;
rules['no-mixed-content'] = S5730_1.rule;
rules['no-nested-assignment'] = S1121_1.rule;
rules['no-nested-conditional'] = S3358_1.rule;
rules['no-nested-functions'] = S2004_1.rule;
rules['no-nested-incdec'] = S881_1.rule;
rules['no-nested-switch'] = S1821_1.rule;
rules['no-nested-template-literals'] = S4624_1.rule;
rules['no-one-iteration-loop'] = S1751_1.rule;
rules['no-os-command-from-path'] = S4036_1.rule;
rules['no-parameter-reassignment'] = S1226_1.rule;
rules['no-primitive-wrappers'] = S1533_1.rule;
rules['no-redeclare'] = S2814_1.rule;
rules['no-redundant-assignments'] = S4165_1.rule;
rules['no-redundant-boolean'] = S1125_1.rule;
rules['no-redundant-jump'] = S3626_1.rule;
rules['no-redundant-optional'] = S4782_1.rule;
rules['no-redundant-parentheses'] = S1110_1.rule;
rules['no-redundant-type-constituents'] = S6571_1.rule;
rules['no-reference-error'] = S3827_1.rule;
rules['no-referrer-policy'] = S5736_1.rule;
rules['no-require-or-define'] = S3533_1.rule;
rules['no-return-type-any'] = S4324_1.rule;
rules['no-same-argument-assert'] = S5863_1.rule;
rules['no-same-line-conditional'] = S3972_1.rule;
rules['no-self-compare'] = S6679_1.rule;
rules['no-small-switch'] = S1301_1.rule;
rules['no-tab'] = S105_1.rule;
rules['no-table-as-layout'] = S5257_1.rule;
rules['no-this-alias'] = S4327_1.rule;
rules['no-throw-literal'] = S3696_1.rule;
rules['no-try-promise'] = S4822_1.rule;
rules['no-undefined-argument'] = S4623_1.rule;
rules['no-undefined-assignment'] = S2138_1.rule;
rules['no-unenclosed-multiline-block'] = S2681_1.rule;
rules['no-uniq-key'] = S6486_1.rule;
rules['no-unknown-property'] = S6747_1.rule;
rules['no-unreachable'] = S1763_1.rule;
rules['no-unsafe'] = S6791_1.rule;
rules['no-unsafe-unzip'] = S5042_1.rule;
rules['no-unstable-nested-components'] = S6478_1.rule;
rules['no-unthrown-error'] = S3984_1.rule;
rules['no-unused-collection'] = S4030_1.rule;
rules['no-unused-expressions'] = S905_1.rule;
rules['no-unused-function-argument'] = S1172_1.rule;
rules['no-unused-private-class-members'] = S1068_1.rule;
rules['no-use-of-empty-return-value'] = S3699_1.rule;
rules['no-useless-call'] = S6676_1.rule;
rules['no-useless-catch'] = S2737_1.rule;
rules['no-useless-constructor'] = S6647_1.rule;
rules['no-useless-increment'] = S2123_1.rule;
rules['no-useless-intersection'] = S4335_1.rule;
rules['no-useless-react-setstate'] = S6443_1.rule;
rules['no-var'] = S3504_1.rule;
rules['no-variable-usage-before-declaration'] = S1526_1.rule;
rules['no-vue-bypass-sanitization'] = S6299_1.rule;
rules['no-weak-cipher'] = S5547_1.rule;
rules['no-weak-keys'] = S4426_1.rule;
rules['no-wildcard-import'] = S2208_1.rule;
rules['non-existent-operator'] = S2757_1.rule;
rules['non-number-in-arithmetic-expression'] = S3760_1.rule;
rules['null-dereference'] = S2259_1.rule;
rules['object-alt-content'] = S5264_1.rule;
rules['object-shorthand'] = S3498_1.rule;
rules['operation-returning-nan'] = S3757_1.rule;
rules['os-command'] = S4721_1.rule;
rules['post-message'] = S2819_1.rule;
rules['prefer-default-last'] = S4524_1.rule;
rules['prefer-enum-initializers'] = S6572_1.rule;
rules['prefer-for-of'] = S4138_1.rule;
rules['prefer-function-type'] = S6598_1.rule;
rules['prefer-immediate-return'] = S1488_1.rule;
rules['prefer-namespace-keyword'] = S4156_1.rule;
rules['prefer-nullish-coalescing'] = S6606_1.rule;
rules['prefer-object-literal'] = S2428_1.rule;
rules['prefer-object-spread'] = S6661_1.rule;
rules['prefer-promise-shorthand'] = S4634_1.rule;
rules['prefer-single-boolean-return'] = S1126_1.rule;
rules['prefer-spread'] = S6666_1.rule;
rules['prefer-string-starts-ends-with'] = S6557_1.rule;
rules['prefer-template'] = S3512_1.rule;
rules['prefer-type-guard'] = S4322_1.rule;
rules['prefer-while'] = S1264_1.rule;
rules['process-argv'] = S4823_1.rule;
rules['production-debug'] = S4507_1.rule;
rules['pseudo-random'] = S2245_1.rule;
rules['public-static-readonly'] = S1444_1.rule;
rules['publicly-writable-directories'] = S5443_1.rule;
rules['reduce-initial-value'] = S6959_1.rule;
rules['redundant-type-aliases'] = S6564_1.rule;
rules['regex-complexity'] = S5843_1.rule;
rules['regular-expr'] = S4784_1.rule;
rules['rules-of-hooks'] = S6440_1.rule;
rules['semi'] = S1438_1.rule;
rules['session-regeneration'] = S5876_1.rule;
rules['shorthand-property-grouping'] = S3499_1.rule;
rules['single-char-in-character-classes'] = S6397_1.rule;
rules['single-character-alternation'] = S6035_1.rule;
rules['slow-regex'] = S5852_1.rule;
rules['sockets'] = S4818_1.rule;
rules['sonar-block-scoped-var'] = S2392_1.rule;
rules['sonar-jsx-no-leaked-render'] = S6439_1.rule;
rules['sonar-max-lines'] = S104_1.rule;
rules['sonar-max-lines-per-function'] = S138_1.rule;
rules['sonar-max-params'] = S107_1.rule;
rules['sonar-no-control-regex'] = S6324_1.rule;
rules['sonar-no-dupe-keys'] = S1534_1.rule;
rules['sonar-no-empty-character-class'] = S2639_1.rule;
rules['sonar-no-fallthrough'] = S128_1.rule;
rules['sonar-no-invalid-regexp'] = S5856_1.rule;
rules['sonar-no-magic-numbers'] = S109_1.rule;
rules['sonar-no-misleading-character-class'] = S5868_1.rule;
rules['sonar-no-regex-spaces'] = S6326_1.rule;
rules['sonar-no-unused-class-component-methods'] = S6441_1.rule;
rules['sonar-no-unused-vars'] = S1481_1.rule;
rules['sonar-prefer-optional-chain'] = S6582_1.rule;
rules['sonar-prefer-read-only-props'] = S6759_1.rule;
rules['sonar-prefer-regexp-exec'] = S6594_1.rule;
rules['sql-queries'] = S2077_1.rule;
rules['stable-tests'] = S5973_1.rule;
rules['standard-input'] = S4829_1.rule;
rules['stateful-regex'] = S6351_1.rule;
rules['strict-transport-security'] = S5739_1.rule;
rules['strings-comparison'] = S3003_1.rule;
rules['super-invocation'] = S3854_1.rule;
rules['switch-without-default'] = S131_1.rule;
rules['table-header'] = S5256_1.rule;
rules['table-header-reference'] = S5260_1.rule;
rules['test-check-exception'] = S5958_1.rule;
rules['todo-tag'] = S1135_1.rule;
rules['too-many-break-or-continue-in-loop'] = S135_1.rule;
rules['unicode-aware-regex'] = S5867_1.rule;
rules['unnecessary-character-escapes'] = S6535_1.rule;
rules['unused-import'] = S1128_1.rule;
rules['unused-named-groups'] = S5860_1.rule;
rules['unverified-certificate'] = S4830_1.rule;
rules['unverified-hostname'] = S5527_1.rule;
rules['updated-const-var'] = S3500_1.rule;
rules['updated-loop-counter'] = S2310_1.rule;
rules['use-isnan'] = S2688_1.rule;
rules['use-type-alias'] = S4323_1.rule;
rules['useless-string-operation'] = S1154_1.rule;
rules['values-not-convertible-to-numbers'] = S3758_1.rule;
rules['variable-name'] = S117_1.rule;
rules['void-use'] = S3735_1.rule;
rules['weak-ssl'] = S4423_1.rule;
rules['web-sql-database'] = S2817_1.rule;
rules['x-powered-by'] = S5689_1.rule;
rules['xml-parser-xxe'] = S2755_1.rule;
rules['xpath'] = S4817_1.rule;
const recommendedLegacyConfig = { plugins: ['sonarjs'], rules: {} };
const recommendedConfig = {
    name: 'sonarjs/recommended',
    plugins: {
        sonarjs: {
            rules,
        },
    },
    rules: {},
    settings: {
        react: {
            version: '999.999.999',
        },
    },
};
for (const [key, rule] of Object.entries(rules)) {
    const recommended = !!rule.meta.docs?.recommended;
    recommendedConfig.rules[`sonarjs/${key}`] = recommended ? 'error' : 'off';
}
recommendedLegacyConfig.rules = recommendedConfig.rules;
exports.configs = {
    recommended: recommendedConfig,
    'recommended-legacy': recommendedLegacyConfig,
};
/*
 package.json may be in current or parent dir depending on running with ts-jest or built js files
 we need to find it in both cases
 */
const packageJsonPath = (0, helpers_1.findParent)(__dirname, 'package.json');
const { name, version } = (packageJsonPath ? JSON.parse(fs_1.default.readFileSync(packageJsonPath, 'utf-8')) : {});
exports.meta = {
    name,
    version,
};
exports.default = { rules, configs: exports.configs, meta: exports.meta };
__exportStar(require("./helpers"), exports);
//# sourceMappingURL=index.js.map